
set xact_abort on
BEGIN TRAN

--  
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__MEASURE_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__MEASURE_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )

ELSE 
	DELETE FROM [dbo].[__MEASURE_SMETA_KS]


IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].MEASURE'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].MEASURE DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].MEASURE ADD [LINK_OLD] INT NULL
GO

IF OBJECT_ID('TEMPDB..#TAB1','U') IS NOT NULL
	DROP TABLE #TAB1

SELECT 
	CODE    = isnull(RIGHT(LTRIM(RTRIM(d.CODE {WORK_COLLATE})),5),''),
	SNAME   = LEFT(LTRIM(RTRIM(d.NAME {WORK_COLLATE})),30), 
	NAME    = LTRIM(RTRIM(d.NAME {WORK_COLLATE})) , 
	LINK_DEP = {LINK_DEP_MAIN},
	[LINK_OLD] = d.LINK
INTO
	#TAB1	
FROM 
	{Variable_SmetaDb}.dbo.DICTION d
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS so ON LTRIM(RTRIM(so.CODE {WORK_COLLATE})) = 'DICTIONARY_DIGIT' AND d.[OBJECT] = so.LINK
ORDER BY 
	d.Code

--   
INSERT INTO [{Variable_TempDb}].[dbo].[__MEASURE_SMETA_KS] ([LINK_NEW],[LINK_OLD]) 
SELECT 
	[LINK_NEW] = P.LINK,
	D.[LINK_OLD]
FROM 
	#TAB1 d
	INNER JOIN (
		SELECT [LINK], [NAME], NUM = ROW_NUMBER() OVER (PARTITION BY NAME ORDER BY LINK)
		FROM [{Variable_WorkDb}].dbo.MEASURE
		WHERE LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND P.[NAME] = LEFT(d.NAME,254)

--
INSERT INTO [{Variable_WorkDb}].dbo.MEASURE
	(CODE,[SNAME],[NAME],LINK_DEP,[LINK_OLD])
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
	INTO [{Variable_TempDb}].[dbo].[__MEASURE_SMETA_KS]
SELECT 
	D.CODE,
	D.SNAME,
	D.NAME, 
	D.LINK_DEP,
	D.[LINK_OLD]
FROM 
	#TAB1 D
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__MEASURE_SMETA_KS] T WHERE T.[LINK_OLD] = D.[LINK_OLD])

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].MEASURE DROP COLUMN [LINK_OLD]
GO
COMMIT TRAN

